--
-- register
-- registration of TurnSignalHud specialization
--
-- @author      Karol Gruszczyk (MySQly)
-- @version     v1.0
-- @date        17/01/17
-- @history:    v1.0 - Initial version
--

RegistrationHelper_TSH = {}
RegistrationHelper_TSH.isLoaded = false

if SpecializationUtil.specializations['TurnSignalHud'] == nil then
    SpecializationUtil.registerSpecialization('TurnSignalHud', 'TurnSignalHud', g_currentModDirectory .. 'TurnSignalHud.lua')
    RegistrationHelper_TSH.isLoaded = false
end

function RegistrationHelper_TSH:loadMap(name)
    if not g_currentMission.RegistrationHelper_TSH_isLoaded then
        if not RegistrationHelper_TSH.isLoaded then
            self:register()
        end
        g_currentMission.RegistrationHelper_TSH_isLoaded = true
    else
        print("Error: TurnSignalHud has been loaded already!")
    end
end

function RegistrationHelper_TSH:deleteMap()
    g_currentMission.RegistrationHelper_TSH_isLoaded = nil
end

function RegistrationHelper_TSH:keyEvent(unicode, sym, modifier, isDown)
end

function RegistrationHelper_TSH:mouseEvent(posX, posY, isDown, isUp, button)
end

function RegistrationHelper_TSH:update(dt)
end

function RegistrationHelper_TSH:draw()
end

function RegistrationHelper_TSH:register()
    for _, vehicle in pairs(VehicleTypeUtil.vehicleTypes) do
        if vehicle ~= nil and SpecializationUtil.hasSpecialization(Drivable, vehicle.specializations) then
            table.insert(vehicle.specializations, SpecializationUtil.getSpecialization("TurnSignalHud"))
        end
    end

    RegistrationHelper_TSH.isLoaded = true
end

addModEventListener(RegistrationHelper_TSH)
